#include "font.h"
#include "mojirend_x.h"

#define FONT_NAME "-kochi-gothic-medium-r-*-*-%d-*-0-0-*-*-*-*"

static XFontSet fontset=NULL;	/* $B$($($N$+$$$J!D(B */

int set_font( int pxlsize )
{
	char tmp[256];
	char **missing;
	int miss_count;

	if ( fontset != NULL ) {
		XFreeFontSet( display, fontset );
	}

	sprintf( tmp, FONT_NAME, pxlsize );
	fontset = XCreateFontSet( display, tmp, &missing, &miss_count, NULL );
	printf("%d\n", miss_count);
}

void set_textcolor( int col )
{
	GC gc = DefaultGC( display, SCREEN );
	XGCValues val;

	val.foreground = WhitePixel( display, SCREEN );
	XChangeGC( display, gc, GCForeground, &val );
}

void put_text( char *text, int x, int y )
{
	GC gc = DefaultGC( display, SCREEN );
	XmbDrawString( display, backpix, fontset, gc, x, y, text, strlen(text) );
	XSync( display, False );
}
