#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/extensions/XShm.h>

#include <sys/shm.h>
#include <locale.h>
#include <string.h>

#include "mojirend.h"
#include "mojirend_x.h"

#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480

/* ??ʤ̵?? */
extern void XDestroyImage( XImage * );

Display *display;
Window mainwin;
static XShmSegmentInfo shm_pix;

Pixmap backpix;
char *backbuf;

int scr_depth;
int bpl;			/* bytes_per_line */

static void create_pixmap()
{
	XImage *img;

	int format = XShmPixmapFormat(display);
	const int depth=scr_depth;

	/* bytes_per_line  */
	img = XShmCreateImage( display, VISUAL, depth, format, NULL,
			       &shm_pix, SCREEN_WIDTH, SCREEN_HEIGHT );
	bpl = img->bytes_per_line;
	shm_pix.shmid = shmget( IPC_PRIVATE, bpl*img->height, IPC_CREAT|0600 );
	shm_pix.readOnly = 0;
	backbuf = shm_pix.shmaddr = shmat( shm_pix.shmid, 0, 0 );
	XDestroyImage( img );

	XShmAttach( display, &shm_pix );
	XSync( display, False );

	backpix = XShmCreatePixmap( display, mainwin, shm_pix.shmaddr, &shm_pix, SCREEN_WIDTH, SCREEN_HEIGHT, depth );

	memset( shm_pix.shmaddr, 0x0, bpl*SCREEN_HEIGHT );

	shmctl( shm_pix.shmid, IPC_RMID, 0 );
}

int init()
{
	setlocale( LC_ALL, "" );

	display = XOpenDisplay( NULL );
	scr_depth = DefaultDepth(display,SCREEN);

	mainwin = XCreateSimpleWindow( display, RootWindow(display,SCREEN),
				       0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, WhitePixel(display, SCREEN) );

	XSelectInput( display, mainwin, KeyPressMask | ButtonPressMask | ExposureMask );

	XRaiseWindow( display, mainwin );
	XMapWindow( display, mainwin );

	XFlush( display );

	create_pixmap();

	return 0;
}


void update( )
{
	GC gc = DefaultGC( display, SCREEN );
	XCopyArea( display, backpix, mainwin, gc, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0 , 0 );
	XSync( display, False );
}

int end_flag;

static void key_press( XKeyEvent *ev )
{
	if ( XKeycodeToKeysym( display, ev->keycode, 0 ) == XK_Escape )
		end_flag = 1;
}


void check_event()
{
	XEvent ev;
	while ( XCheckMaskEvent(display, KeyPressMask | ButtonPressMask | ExposureMask, &ev ) ) {
		switch ( ev.type ) {
/*		case ButtonPress:
			ret = button_press( (XButtonEvent*)&ev );
			break;*/

		case KeyPress:
			key_press( (XKeyEvent*)&ev );
			break;
			
		}
	}
}
